Index: test/bfs_test.cc
===================================================================
--- test/bfs_test.cc	(revision 228)
+++ test/bfs_test.cc	(revision 209)
@@ -20,5 +20,4 @@
 #include <lemon/smart_graph.h>
 #include <lemon/list_graph.h>
-#include <lemon/lgf_reader.h>
 #include <lemon/bfs.h>
 #include <lemon/path.h>
@@ -28,26 +27,4 @@
 
 using namespace lemon;
-
-char test_lgf[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "5\n"
-  "@arcs\n"
-  "     label\n"
-  "0 1  0\n"
-  "1 2  1\n"
-  "2 3  2\n"
-  "3 4  3\n"
-  "0 3  4\n"
-  "0 3  5\n"
-  "5 2  6\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 4\n";
 
 void checkBfsCompile()
@@ -73,5 +50,4 @@
   n  = bfs_test.predNode(n);
   d  = bfs_test.distMap();
-
   p  = bfs_test.predMap();
   //  pn = bfs_test.predNodeMap();
@@ -105,18 +81,16 @@
   Digraph G;
   Node s, t;
+  PetStruct<Digraph> ps = addPetersen(G, 5);
 
-  std::istringstream input(test_lgf);
-  digraphReader(input, G).
-    node("source", s).
-    node("target", t).
-    run();
+  s=ps.outer[2];
+  t=ps.inner[0];
 
   Bfs<Digraph> bfs_test(G);
   bfs_test.run(s);
 
-  check(bfs_test.dist(t)==2,"Bfs found a wrong path." << bfs_test.dist(t));
+  check(bfs_test.dist(t)==3,"Bfs found a wrong path." << bfs_test.dist(t));
 
   Path<Digraph> p = bfs_test.path(t);
-  check(p.length()==2,"path() found a wrong path.");
+  check(p.length()==3,"path() found a wrong path.");
   check(checkPath(G, p),"path() found a wrong path.");
   check(pathSource(G, p) == s,"path() found a wrong path.");
@@ -124,24 +98,22 @@
 
 
-  for(ArcIt a(G); a!=INVALID; ++a) {
-    Node u=G.source(a);
-    Node v=G.target(a);
+  for(ArcIt e(G); e==INVALID; ++e) {
+    Node u=G.source(e);
+    Node v=G.target(e);
     check( !bfs_test.reached(u) ||
-           (bfs_test.dist(v) <= bfs_test.dist(u)+1),
-           "Wrong output." << G.id(v) << ' ' << G.id(u));
+           (bfs_test.dist(v) > bfs_test.dist(u)+1),
+           "Wrong output.");
   }
 
-  for(NodeIt v(G); v!=INVALID; ++v) {
-    if (bfs_test.reached(v)) {
-      check(v==s || bfs_test.predArc(v)!=INVALID, "Wrong tree.");
-      if (bfs_test.predArc(v)!=INVALID ) {
-        Arc a=bfs_test.predArc(v);
-        Node u=G.source(a);
-        check(u==bfs_test.predNode(v),"Wrong tree.");
-        check(bfs_test.dist(v) - bfs_test.dist(u) == 1,
-              "Wrong distance. Difference: "
-              << std::abs(bfs_test.dist(v) - bfs_test.dist(u)
-                          - 1));
-      }
+  for(NodeIt v(G); v==INVALID; ++v) {
+    check(bfs_test.reached(v),"Each node should be reached.");
+    if ( bfs_test.predArc(v)!=INVALID ) {
+      Arc e=bfs_test.predArc(v);
+      Node u=G.source(e);
+      check(u==bfs_test.predNode(v),"Wrong tree.");
+      check(bfs_test.dist(v) - bfs_test.dist(u) == 1,
+            "Wrong distance. Difference: "
+            << std::abs(bfs_test.dist(v) - bfs_test.dist(u)
+                        - 1));
     }
   }
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 228)
+++ test/dfs_test.cc	(revision 209)
@@ -20,6 +20,4 @@
 #include <lemon/smart_graph.h>
 #include <lemon/list_graph.h>
-#include <lemon/lgf_reader.h>
-
 #include <lemon/dfs.h>
 #include <lemon/path.h>
@@ -29,28 +27,4 @@
 
 using namespace lemon;
-
-char test_lgf[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "5\n"
-  "6\n"
-  "@arcs\n"
-  "     label\n"
-  "0 1  0\n"
-  "1 2  1\n"
-  "2 3  2\n"
-  "1 4  3\n"
-  "4 2  4\n"
-  "4 5  5\n"
-  "5 0  6\n"
-  "6 3  7\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 5\n";
 
 void checkDfsCompile()
@@ -66,4 +40,5 @@
   DType::DistMap d(G);
   DType::PredMap p(G);
+  //  DType::PredNodeMap pn(G);
 
   DType dfs_test(G);
@@ -76,4 +51,5 @@
   d  = dfs_test.distMap();
   p  = dfs_test.predMap();
+  //  pn = dfs_test.predNodeMap();
   b  = dfs_test.reached(n);
 
@@ -105,10 +81,8 @@
   Digraph G;
   Node s, t;
+  PetStruct<Digraph> ps = addPetersen(G, 5);
 
-  std::istringstream input(test_lgf);
-  digraphReader(input, G).
-    node("source", s).
-    node("target", t).
-    run();
+  s=ps.outer[2];
+  t=ps.inner[0];
 
   Dfs<Digraph> dfs_test(G);
@@ -122,14 +96,12 @@
 
   for(NodeIt v(G); v!=INVALID; ++v) {
-    if (dfs_test.reached(v)) {
-      check(v==s || dfs_test.predArc(v)!=INVALID, "Wrong tree.");
-      if (dfs_test.predArc(v)!=INVALID ) {
-        Arc e=dfs_test.predArc(v);
-        Node u=G.source(e);
-        check(u==dfs_test.predNode(v),"Wrong tree.");
-        check(dfs_test.dist(v) - dfs_test.dist(u) == 1,
-              "Wrong distance. (" << dfs_test.dist(u) << "->"
-              <<dfs_test.dist(v) << ')');
-      }
+    check(dfs_test.reached(v),"Each node should be reached.");
+    if ( dfs_test.predArc(v)!=INVALID ) {
+      Arc e=dfs_test.predArc(v);
+      Node u=G.source(e);
+      check(u==dfs_test.predNode(v),"Wrong tree.");
+      check(dfs_test.dist(v) - dfs_test.dist(u) == 1,
+            "Wrong distance. (" << dfs_test.dist(u) << "->"
+            <<dfs_test.dist(v) << ')');
     }
   }
Index: test/digraph_test.cc
===================================================================
--- test/digraph_test.cc	(revision 228)
+++ test/digraph_test.cc	(revision 209)
@@ -25,61 +25,10 @@
 #include "test_tools.h"
 #include "graph_test.h"
+#include "graph_maps_test.h"
 
 using namespace lemon;
 using namespace lemon::concepts;
 
-template <class Digraph>
-void checkDigraph() {
-  TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
-  Digraph G;
-
-  checkGraphNodeList(G, 0);
-  checkGraphArcList(G, 0);
-
-  Node
-    n1 = G.addNode(),
-    n2 = G.addNode(),
-    n3 = G.addNode();
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 0);
-
-  Arc a1 = G.addArc(n1, n2);
-  check(G.source(a1) == n1 && G.target(a1) == n2, "Wrong arc");
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 1);
-
-  checkGraphOutArcList(G, n1, 1);
-  checkGraphOutArcList(G, n2, 0);
-  checkGraphOutArcList(G, n3, 0);
-
-  checkGraphInArcList(G, n1, 0);
-  checkGraphInArcList(G, n2, 1);
-  checkGraphInArcList(G, n3, 0);
-
-  checkGraphConArcList(G, 1);
-
-  Arc a2 = G.addArc(n2, n1), a3 = G.addArc(n2, n3), a4 = G.addArc(n2, n3);
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 4);
-
-  checkGraphOutArcList(G, n1, 1);
-  checkGraphOutArcList(G, n2, 3);
-  checkGraphOutArcList(G, n3, 0);
-
-  checkGraphInArcList(G, n1, 1);
-  checkGraphInArcList(G, n2, 1);
-  checkGraphInArcList(G, n3, 2);
-
-  checkGraphConArcList(G, 4);
-
-  checkNodeIds(G);
-  checkArcIds(G);
-  checkGraphNodeMap(G);
-  checkGraphArcMap(G);
-
-}
-
-
-void checkConcepts() {
+void check_concepts() {
   { // Checking digraph components
     checkConcept<BaseDigraphComponent, BaseDigraphComponent >();
@@ -103,4 +52,5 @@
     checkConcept<ClearableDigraphComponent<>, ListDigraph>();
     checkConcept<ErasableDigraphComponent<>, ListDigraph>();
+    checkDigraphIterators<ListDigraph>();
   }
   { // Checking SmartDigraph
@@ -109,15 +59,18 @@
     checkConcept<ExtendableDigraphComponent<>, SmartDigraph>();
     checkConcept<ClearableDigraphComponent<>, SmartDigraph>();
+    checkDigraphIterators<SmartDigraph>();
   }
 //  { // Checking FullDigraph
 //    checkConcept<Digraph, FullDigraph>();
+//    checkDigraphIterators<FullDigraph>();
 //  }
 //  { // Checking HyperCubeDigraph
 //    checkConcept<Digraph, HyperCubeDigraph>();
+//    checkDigraphIterators<HyperCubeDigraph>();
 //  }
 }
 
 template <typename Digraph>
-void checkDigraphValidity() {
+void check_graph_validity() {
   TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
   Digraph g;
@@ -140,5 +93,5 @@
 
 template <typename Digraph>
-void checkDigraphValidityErase() {
+void check_graph_validity_erase() {
   TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
   Digraph g;
@@ -168,18 +121,24 @@
 }
 
-void checkDigraphs() {
+void check_digraphs() {
   { // Checking ListDigraph
     checkDigraph<ListDigraph>();
-    checkDigraphValidityErase<ListDigraph>();
+    checkGraphNodeMap<ListDigraph>();
+    checkGraphArcMap<ListDigraph>();
+
+    check_graph_validity_erase<ListDigraph>();
   }
   { // Checking SmartDigraph
     checkDigraph<SmartDigraph>();
-    checkDigraphValidity<SmartDigraph>();
+    checkGraphNodeMap<SmartDigraph>();
+    checkGraphArcMap<SmartDigraph>();
+
+    check_graph_validity<SmartDigraph>();
   }
 }
 
 int main() {
-  checkDigraphs();
-  checkConcepts();
+  check_concepts();
+  check_digraphs();
   return 0;
 }
Index: test/dijkstra_test.cc
===================================================================
--- test/dijkstra_test.cc	(revision 228)
+++ test/dijkstra_test.cc	(revision 210)
@@ -20,6 +20,5 @@
 #include <lemon/smart_graph.h>
 #include <lemon/list_graph.h>
-#include <lemon/lgf_reader.h>
-
+#include <lemon/graph_utils.h>
 #include <lemon/dijkstra.h>
 #include <lemon/path.h>
@@ -29,25 +28,4 @@
 
 using namespace lemon;
-
-char test_lgf[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "@arcs\n"
-  "     label length\n"
-  "0 1  0     1\n"
-  "1 2  1     1\n"
-  "2 3  2     1\n"
-  "0 3  4     5\n"
-  "0 3  5     10\n"
-  "0 3  6     7\n"
-  "4 2  7     1\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 3\n";
 
 void checkDijkstraCompile()
@@ -108,11 +86,13 @@
   Node s, t;
   LengthMap length(G);
+  PetStruct<Digraph> ps = addPetersen(G, 5);
 
-  std::istringstream input(test_lgf);
-  digraphReader(input, G).
-    arcMap("length", length).
-    node("source", s).
-    node("target", t).
-    run();
+  for(int i=0;i<5;i++) {
+    length[ps.outcir[i]]=4;
+    length[ps.incir[i]]=1;
+    length[ps.chords[i]]=10;
+  }
+  s=ps.outer[0];
+  t=ps.inner[1];
 
   Dijkstra<Digraph, LengthMap>
@@ -120,8 +100,8 @@
   dijkstra_test.run(s);
 
-  check(dijkstra_test.dist(t)==3,"Dijkstra found a wrong path.");
+  check(dijkstra_test.dist(t)==13,"Dijkstra found a wrong path.");
 
   Path<Digraph> p = dijkstra_test.path(t);
-  check(p.length()==3,"getPath() found a wrong path.");
+  check(p.length()==4,"getPath() found a wrong path.");
   check(checkPath(G, p),"path() found a wrong path.");
   check(pathSource(G, p) == s,"path() found a wrong path.");
@@ -137,15 +117,13 @@
   }
 
-  for(NodeIt v(G); v!=INVALID; ++v) {
-    if (dijkstra_test.reached(v)) {
-      check(v==s || dijkstra_test.predArc(v)!=INVALID, "Wrong tree.");
-      if (dijkstra_test.predArc(v)!=INVALID ) {
-        Arc e=dijkstra_test.predArc(v);
-        Node u=G.source(e);
-        check(u==dijkstra_test.predNode(v),"Wrong tree.");
-        check(dijkstra_test.dist(v) - dijkstra_test.dist(u) == length[e],
-              "Wrong distance! Difference: " <<
-              std::abs(dijkstra_test.dist(v)-dijkstra_test.dist(u)-length[e]));
-      }
+  for(NodeIt v(G); v!=INVALID; ++v){
+    check(dijkstra_test.reached(v),"Each node should be reached.");
+    if ( dijkstra_test.predArc(v)!=INVALID ) {
+      Arc e=dijkstra_test.predArc(v);
+      Node u=G.source(e);
+      check(u==dijkstra_test.predNode(v),"Wrong tree.");
+      check(dijkstra_test.dist(v) - dijkstra_test.dist(u) == length[e],
+            "Wrong distance! Difference: " <<
+            std::abs(dijkstra_test.dist(v)-dijkstra_test.dist(u)-length[e]));
     }
   }
Index: test/dim_test.cc
===================================================================
--- test/dim_test.cc	(revision 242)
+++ test/dim_test.cc	(revision 209)
@@ -59,28 +59,24 @@
   box1.add(b);
 
-  check(box1.left()==1 && box1.bottom()==2 &&
-        box1.right()==3 && box1.top()==4,
+  check(box1.bottomLeft().x==1 &&
+        box1.bottomLeft().y==2 &&
+        box1.topRight().x==3 &&
+        box1.topRight().y==4,
         "Wrong addition of points to dim2::BoundingBox.");
 
-  check(box1.inside(Point(2,3)), "Wrong inside() in dim2::BoundingBox.");
-  check(box1.inside(Point(1,3)), "Wrong inside() in dim2::BoundingBox.");
-  check(!box1.inside(Point(0,3)), "Wrong inside() in dim2::BoundingBox.");
+  p.x=2; p.y=3;
+  check(box1.inside(p), "Wrong inside() in dim2::BoundingBox.");
 
-  BB box2(Point(2,2));
+  p.x=1; p.y=3;
+  check(box1.inside(p), "Wrong inside() in dim2::BoundingBox.");
+
+  p.x=0; p.y=3;
+  check(!box1.inside(p), "Wrong inside() in dim2::BoundingBox.");
+
+  BB box2(p);
   check(!box2.empty(), "Wrong empty() in dim2::BoundingBox.");
-  
-  box2.bottomLeft(Point(2,0));
-  box2.topRight(Point(5,3));
-  BB box3 = box1 & box2;
-  check(!box3.empty() &&
-        box3.left()==2 && box3.bottom()==2 && 
-        box3.right()==3 && box3.top()==3,
-        "Wrong intersection of two dim2::BoundingBox objects.");
-  
-  box1.add(box2);
-  check(!box1.empty() &&
-        box1.left()==1 && box1.bottom()==0 &&
-        box1.right()==5 && box1.top()==4,
-        "Wrong addition of two dim2::BoundingBox objects.");
+
+  box2.add(box1);
+  check(box2.inside(p), "Wrong inside() in dim2::BoundingBox.");
 
   return 0;
Index: test/error_test.cc
===================================================================
--- test/error_test.cc	(revision 223)
+++ test/error_test.cc	(revision 209)
@@ -30,8 +30,4 @@
 #ifdef LEMON_DISABLE_ASSERTS
 #undef LEMON_DISABLE_ASSERTS
-#endif
-
-#ifdef NDEBUG
-#undef NDEBUG
 #endif
 
Index: test/graph_copy_test.cc
===================================================================
--- test/graph_copy_test.cc	(revision 220)
+++ test/graph_copy_test.cc	(revision 209)
@@ -20,4 +20,5 @@
 #include <lemon/list_graph.h>
 #include <lemon/lgf_reader.h>
+#include <lemon/graph_utils.h>
 #include <lemon/error.h>
 
Index: test/graph_maps_test.h
===================================================================
--- test/graph_maps_test.h	(revision 209)
+++ test/graph_maps_test.h	(revision 209)
@@ -0,0 +1,144 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_TEST_MAP_TEST_H
+#define LEMON_TEST_MAP_TEST_H
+
+#include <vector>
+#include <lemon/maps.h>
+
+#include "test_tools.h"
+
+namespace lemon {
+
+  template <typename Graph>
+  void checkGraphNodeMap() {
+    Graph graph;
+    const int num = 16;
+
+    typedef typename Graph::Node Node;
+
+    std::vector<Node> nodes;
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+    }
+    typedef typename Graph::template NodeMap<int> IntNodeMap;
+    IntNodeMap map(graph, 42);
+    for (int i = 0; i < int(nodes.size()); ++i) {
+      check(map[nodes[i]] == 42, "Wrong map constructor.");
+    }
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+      map[nodes.back()] = 23;
+      check(map[nodes.back()] == 23, "Wrong operator[].");
+    }
+    map = constMap<Node>(12);
+    for (int i = 0; i < int(nodes.size()); ++i) {
+      check(map[nodes[i]] == 12, "Wrong map constructor.");
+    }
+    graph.clear();
+    nodes.clear();
+  }
+
+  template <typename Graph>
+  void checkGraphArcMap() {
+    Graph graph;
+    const int num = 16;
+
+    typedef typename Graph::Node Node;
+    typedef typename Graph::Arc Arc;
+
+    std::vector<Node> nodes;
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+    }
+
+    std::vector<Arc> arcs;
+    for (int i = 0; i < num; ++i) {
+      for (int j = 0; j < i; ++j) {
+        arcs.push_back(graph.addArc(nodes[i], nodes[j]));
+      }
+    }
+
+    typedef typename Graph::template ArcMap<int> IntArcMap;
+    IntArcMap map(graph, 42);
+
+    for (int i = 0; i < int(arcs.size()); ++i) {
+      check(map[arcs[i]] == 42, "Wrong map constructor.");
+    }
+
+    for (int i = 0; i < num; ++i) {
+      for (int j = i + 1; j < num; ++j) {
+        arcs.push_back(graph.addArc(nodes[i], nodes[j]));
+        map[arcs.back()] = 23;
+        check(map[arcs.back()] == 23, "Wrong operator[].");
+      }
+    }
+    map = constMap<Arc>(12);
+    for (int i = 0; i < int(arcs.size()); ++i) {
+      check(map[arcs[i]] == 12, "Wrong map constructor.");
+    }
+    graph.clear();
+    arcs.clear();
+  }
+
+  template <typename Graph>
+  void checkGraphEdgeMap() {
+    Graph graph;
+    const int num = 16;
+
+    typedef typename Graph::Node Node;
+    typedef typename Graph::Edge Edge;
+
+    std::vector<Node> nodes;
+    for (int i = 0; i < num; ++i) {
+      nodes.push_back(graph.addNode());
+    }
+
+    std::vector<Edge> edges;
+    for (int i = 0; i < num; ++i) {
+      for (int j = 0; j < i; ++j) {
+        edges.push_back(graph.addEdge(nodes[i], nodes[j]));
+      }
+    }
+
+    typedef typename Graph::template EdgeMap<int> IntEdgeMap;
+    IntEdgeMap map(graph, 42);
+
+    for (int i = 0; i < int(edges.size()); ++i) {
+      check(map[edges[i]] == 42, "Wrong map constructor.");
+    }
+
+    for (int i = 0; i < num; ++i) {
+      for (int j = i + 1; j < num; ++j) {
+        edges.push_back(graph.addEdge(nodes[i], nodes[j]));
+        map[edges.back()] = 23;
+        check(map[edges.back()] == 23, "Wrong operator[].");
+      }
+    }
+    map = constMap<Edge>(12);
+    for (int i = 0; i < int(edges.size()); ++i) {
+      check(map[edges[i]] == 12, "Wrong map constructor.");
+    }
+    graph.clear();
+    edges.clear();
+  }
+
+}
+
+#endif
Index: test/graph_test.cc
===================================================================
--- test/graph_test.cc	(revision 228)
+++ test/graph_test.cc	(revision 209)
@@ -25,76 +25,10 @@
 #include "test_tools.h"
 #include "graph_test.h"
+#include "graph_maps_test.h"
 
 using namespace lemon;
 using namespace lemon::concepts;
 
-template <class Graph>
-void checkGraph() {
-  TEMPLATE_GRAPH_TYPEDEFS(Graph);
-
-  Graph G;
-  checkGraphNodeList(G, 0);
-  checkGraphEdgeList(G, 0);
-
-  Node
-    n1 = G.addNode(),
-    n2 = G.addNode(),
-    n3 = G.addNode();
-  checkGraphNodeList(G, 3);
-  checkGraphEdgeList(G, 0);
-
-  Edge e1 = G.addEdge(n1, n2);
-  check((G.u(e1) == n1 && G.v(e1) == n2) || (G.u(e1) == n2 && G.v(e1) == n1),
-        "Wrong edge");
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 2);
-  checkGraphEdgeList(G, 1);
-
-  checkGraphOutArcList(G, n1, 1);
-  checkGraphOutArcList(G, n2, 1);
-  checkGraphOutArcList(G, n3, 0);
-
-  checkGraphInArcList(G, n1, 1);
-  checkGraphInArcList(G, n2, 1);
-  checkGraphInArcList(G, n3, 0);
-
-  checkGraphIncEdgeList(G, n1, 1);
-  checkGraphIncEdgeList(G, n2, 1);
-  checkGraphIncEdgeList(G, n3, 0);
-
-  checkGraphConArcList(G, 2);
-  checkGraphConEdgeList(G, 1);
-
-  Edge e2 = G.addEdge(n2, n1), e3 = G.addEdge(n2, n3);
-  checkGraphNodeList(G, 3);
-  checkGraphArcList(G, 6);
-  checkGraphEdgeList(G, 3);
-
-  checkGraphOutArcList(G, n1, 2);
-  checkGraphOutArcList(G, n2, 3);
-  checkGraphOutArcList(G, n3, 1);
-
-  checkGraphInArcList(G, n1, 2);
-  checkGraphInArcList(G, n2, 3);
-  checkGraphInArcList(G, n3, 1);
-
-  checkGraphIncEdgeList(G, n1, 2);
-  checkGraphIncEdgeList(G, n2, 3);
-  checkGraphIncEdgeList(G, n3, 1);
-
-  checkGraphConArcList(G, 6);
-  checkGraphConEdgeList(G, 3);
-
-  checkArcDirections(G);
-
-  checkNodeIds(G);
-  checkArcIds(G);
-  checkEdgeIds(G);
-  checkGraphNodeMap(G);
-  checkGraphArcMap(G);
-  checkGraphEdgeMap(G);
-}
-
-void checkConcepts() {
+void check_concepts() {
   { // Checking graph components
     checkConcept<BaseGraphComponent, BaseGraphComponent >();
@@ -118,4 +52,5 @@
     checkConcept<ClearableGraphComponent<>, ListGraph>();
     checkConcept<ErasableGraphComponent<>, ListGraph>();
+    checkGraphIterators<ListGraph>();
   }
   { // Checking SmartGraph
@@ -124,4 +59,5 @@
     checkConcept<ExtendableGraphComponent<>, SmartGraph>();
     checkConcept<ClearableGraphComponent<>, SmartGraph>();
+    checkGraphIterators<SmartGraph>();
   }
 //  { // Checking FullGraph
@@ -136,5 +72,5 @@
 
 template <typename Graph>
-void checkGraphValidity() {
+void check_graph_validity() {
   TEMPLATE_GRAPH_TYPEDEFS(Graph);
   Graph g;
@@ -159,5 +95,5 @@
 
 template <typename Graph>
-void checkGraphValidityErase() {
+void check_graph_validity_erase() {
   TEMPLATE_GRAPH_TYPEDEFS(Graph);
   Graph g;
@@ -233,12 +169,18 @@
 // }
 
-void checkGraphs() {
+void check_graphs() {
   { // Checking ListGraph
     checkGraph<ListGraph>();
-    checkGraphValidityErase<ListGraph>();
+    checkGraphNodeMap<ListGraph>();
+    checkGraphEdgeMap<ListGraph>();
+
+    check_graph_validity_erase<ListGraph>();
   }
   { // Checking SmartGraph
     checkGraph<SmartGraph>();
-    checkGraphValidity<SmartGraph>();
+    checkGraphNodeMap<SmartGraph>();
+    checkGraphEdgeMap<SmartGraph>();
+
+    check_graph_validity<SmartGraph>();
   }
 //   { // Checking FullGraph
@@ -256,6 +198,6 @@
 
 int main() {
-  checkConcepts();
-  checkGraphs();
+  check_concepts();
+  check_graphs();
   return 0;
 }
